@echo off

REM ===========================================================================

REM *** please check through this before you run it ***

REM this script requires
REM   > call tsvn_resolve_bug.bat & REM to run

REM This is an MS-DOS batch file
REM it assumes the existence of C:/Temp on Windoze
REM it deletes abd creates some files and directories

REM written using SVN 1.5.3

REM ===========================================================================

if exist C:\Temp\trb_repo (
	rmdir /S /Q C:\Temp\trb_repo & REM dangerous!
)

if exist trb_wc (
	rmdir /S /Q trb_wc & REM dangerous!
)

SET repo_url="file://localhost/c:/Temp/trb_repo/"

REM create a repository
svnadmin create "c:/Temp/trb_repo" || ( echo "create fail" & goto exit )

REM create a working copy
svn checkout "%repo_url%" trb_wc || ( echo "co fail" & goto exit )

REM populate the wc trunk
mkdir trb_wc\trunk || ( echo "mkdir fail" & goto exit )
echo "some file text" > trb_wc/trunk/file.txt || ( echo "init echo fail" & goto exit )
svn add trb_wc/trunk || ( echo "init add fail" & goto exit )
svn propset property_name "some property text" trb_wc/trunk || ( echo "init pset fail" & goto exit )

REM commit the trunk
svn commit --message "initial version" trb_wc/trunk || ( echo "init ci fail" & goto exit )
svn update trb_wc || ( echo "init up fail" & goto exit )

REM create a branch
svn copy --message "create branch" -r1 "%repo_url%trunk" "%repo_url%branch" || ( echo "cp fail" & goto exit )
svn update trb_wc || ( echo "up (2) fail" & goto exit )

REM perform some "development" on both trunk and branch
echo "some trunk file text" > trb_wc/trunk/file.txt || ( echo "trunk echo fail" & goto exit )
svn propset property_name "some trunk property text" trb_wc/trunk || ( echo "trunk pset fail" & goto exit )
svn commit --message "trunk dev" trb_wc/trunk || ( echo "trunk ci fail" & goto exit )
echo "some branch file text" > trb_wc/branch/file.txt || ( echo "branch echo fail" & goto exit )
svn propset property_name "some branch property text" trb_wc/branch || ( echo "branch pset fail" & goto exit )
svn commit --message "branch dev" trb_wc/branch || ( echo "branch ci fail" & goto exit )
svn update trb_wc || ( echo "up (3) fail" & goto exit )

REM finally, merge branch to trunk!
( svn log --change 4 --verbose "%repo_url%branch" > svn-log.branch.stdout.txt ) || ( echo "log fail" & goto exit )
type svn-log.branch.stdout.txt
( svn merge --accept postpone --change 4 "%repo_url%branch" trb_wc/trunk/ > svn-merge.stdout.txt ) || ( echo "merge fail" & goto exit )
type svn-merge.stdout.txt

echo "success"

:exit
