#!/bin/bash

### ===========================================================================

### *** please check through this before you run it ***

### this script requires
###   $ chmod u+x tsvn_resolve_bug.sh ### to mark as executable
###   $ ./tsvn_resolve_bug.sh ### to run

### This is a Cygwin bash script
### it assumes the existence of C:/Temp on Windoze
### it deletes and creates some files and directories

### written using SVN 1.5.3

### ===========================================================================

if [ -e /cygdrive/c/Temp/trb_repo ]
then
	#true ### [no operation]
	rm -rf /cygdrive/c/Temp/trb_repo ### dangerous!
fi

if [ -e trb_wc ]
then
	#true ### [no operation]
	rm -rf trb_wc ### dangerous!
fi

repo_url="file://localhost/c|/Temp/trb_repo/"

### create a repository
svnadmin create "c:/Temp/trb_repo" || { echo "create fail" ; exit 1 ; }

### create a working copy
svn checkout "${repo_url}" trb_wc || { echo "co fail" ; exit 1 ; }

### populate the wc trunk
mkdir trb_wc/trunk/ || { echo "mkdir fail" ; exit 1 ; }
echo "some file text" > trb_wc/trunk/file.txt || { echo "init echo fail" ; exit 1 ; }
svn add trb_wc/trunk || { echo "init add fail" ; exit 1 ; }
svn propset property_name "some property text" trb_wc/trunk || { echo "init pset fail" ; exit 1 ; }

### commit the trunk
svn commit --message "initial version" trb_wc/trunk || { echo "init ci fail" ; exit 1 ; }
svn update trb_wc || { echo "init up fail" ; exit 1 ; }

### create a branch
svn copy --message "create branch" -r1 "${repo_url}trunk" "${repo_url}branch" || { echo "cp fail" ; exit 1 ; }
svn update trb_wc || { echo "up (2) fail" ; exit 1 ; }

### perform some "development" on both trunk and branch
echo "some trunk file text" > trb_wc/trunk/file.txt || { echo "trunk echo fail" ; exit 1 ; }
svn propset property_name "some trunk property text" trb_wc/trunk || { echo "trunk pset fail" ; exit 1 ; }
svn commit --message "trunk dev" trb_wc/trunk || { echo "trunk ci fail" ; exit 1 ; }
echo "some branch file text" > trb_wc/branch/file.txt || { echo "branch echo fail" ; exit 1 ; }
svn propset property_name "some branch property text" trb_wc/branch || { echo "branch pset fail" ; exit 1 ; }
svn commit --message "branch dev" trb_wc/branch || { echo "branch ci fail" ; exit 1 ; }
svn update trb_wc || { echo "up (3) fail" ; exit 1 ; }

### finally, merge branch to trunk!
{ svn log --change 4 --verbose "${repo_url}branch" > svn-log.branch.stdout.txt ; } || { echo "log fail" ; exit 1 ; }
cat svn-log.branch.stdout.txt
{ svn merge --accept postpone --change 4 "${repo_url}branch" trb_wc/trunk/ > svn-merge.stdout.txt ; } || { echo "merge fail" ; exit 1 ; }
cat svn-merge.stdout.txt

echo "success"
